"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var core_1 = require("@angular/core");
var baasic_sdk_javascript_1 = require("baasic-sdk-javascript");
var http_client_factory_1 = require("infrastructure/httpApi/http-client.factory");
var services_1 = require("services");
var apiKeyToken = new core_1.OpaqueToken('ApiKey');
var optionToken = new core_1.OpaqueToken('IAppOptions');
var BaasicApp = BaasicApp_1 = (function (_super) {
    tslib_1.__extends(BaasicApp, _super);
    function BaasicApp(apiKey, options, httpClientFactory) {
        return _super.call(this, apiKey, getOptions(options, httpClientFactory)) || this;
    }
    BaasicApp.forRoot = function (apiKey, options) {
        return {
            ngModule: BaasicApp_1,
            providers: [{
                    provide: optionToken,
                    useValue: options
                }, {
                    provide: apiKeyToken,
                    useValue: apiKey
                }]
        };
    };
    return BaasicApp;
}(baasic_sdk_javascript_1.BaasicApp));
BaasicApp = BaasicApp_1 = tslib_1.__decorate([
    core_1.NgModule({
        providers: [
            http_client_factory_1.HttpClientFactory,
            services_1.ApplicationSettingsService,
            services_1.ArticleService,
            services_1.CommerceService,
            services_1.DynamicResourceService,
            services_1.FilesService,
            services_1.KeyValueService,
            services_1.MediaVaultService,
            services_1.MembershipService,
            services_1.MeteringService,
            services_1.NotificationsService,
            services_1.TemplatingService,
            services_1.UserProfileService,
            services_1.ValueSetService
        ]
    }),
    tslib_1.__param(0, core_1.Inject(apiKeyToken)), tslib_1.__param(1, core_1.Inject(optionToken)),
    tslib_1.__metadata("design:paramtypes", [String, Object, http_client_factory_1.HttpClientFactory])
], BaasicApp);
exports.BaasicApp = BaasicApp;
;
function getOptions(options, httpClientFactory) {
    options = options || {};
    if (!options.httpClient) {
        options.httpClient = httpClientFactory.get;
    }
    return options;
}
var BaasicApp_1;
